<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2010 Coppermine Dev Team
  v1.0 originally written by Gregory Demar

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.

  ********************************************
  Coppermine version: 1.5.6
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/trunk/cpg1.5.x/plugins/link_target/codebase.php $
  $Revision: 7620 $
**********************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$superCage = Inspekt::makeSuperCage();


global $facebook, $session, ;

require ('./plugins/fb_oauth/include/fbconnect.php');

/**************
 * Edit Below */
$facebook = new Facebook(array(
  'appId'  => 'YOUR_APP_ID',
  'secret' => 'YOUR_SECRET_KEY',
  'cookie' => true,
));
$login_params = array(
	'req_perms' => 'email', 
	'next' => 'LINK_TO_YOUR_SITE_AFTER_AUTH', 
	'cancel_url' => 'LINK_TO_YOUR_SITE_AFTER_CANCEL'
	);
	/* Edit Above *
	 **************/

$session = $facebook->getSession();

if($USER_DATA==0 && !empty($session)){
	define('LOGIN_PHP', true);
}

// We may or may not have this data based on a $_GET or $_COOKIE based session.
//
// If we get a session here, it means we found a correctly signed session using
// the Application Secret only Facebook and the Application know. We dont know
// if it is still valid until we make an API call using the session. A session
// can become invalid if it has already expired (should not be getting the
// session back in this case) or if the user logged out of Facebook.



$thisplugin->add_action('page_start','fboa_init');
$thisplugin->add_filter('sys_menu','add_sub_button');

function add_sub_button($menu) {
	global $facebook, $session, $login_params;
	
	
	$me = null;
	// Session based API call.
	if (!empty($session)) {
	  try {
	    $uid = $facebook->getUser();
	    $me = $facebook->api('/me');
	  } catch (FacebookApiException $e) {
	    error_log($e);
	  }
	}
	// login or logout url will be needed depending on current user state.
	if ($me) {
	  $buttonLnk = $facebook->getLogoutURL();
		$buttonTtl = '<img src="https://graph.facebook.com/'.$uid.'/picture">';
		
		$menu[11][2] = $buttonLnk;
		
	} else {
	  $buttonLnk = $facebook->getLoginUrl($login_params);
		$buttonTtl = '<img src="http://static.ak.fbcdn.net/rsrc.php/zB6N8/hash/4li2k73z.gif">';
	}
	
	$new_button = array();
	$new_button[0][0] = $buttonTtl;
	$new_button[0][1] = 'menu link';
	$new_button[0][2] = $buttonLnk;
	$new_button[0][3] = 'fb_oauth';
	$new_button[0][4] = '::';
	$new_button[0][5] = 'rel="nofollow"';
	
	
	$superCage = Inspekt::makeSuperCage();
		
	array_splice($menu, count($menu)+1, 0, $new_button);		

	return $menu;
}

function fboa_init() {
	global $CONFIG, $JS, $facebook, $session, $USER_DATA, $cpg_udb;
	
	$JS['includes'][] = 'plugins/fb_oauth/include/fbconnect.js';
	
	if($USER_DATA['user_id']!=0 && empty($session))return false;
	
	$me = null;
	// Session based API call.
	if (!empty($session)) {
	  try {
	    $uid = $facebook->getUser();
	    $me = $facebook->api('/me');
	  } catch (FacebookApiException $e) {
	    error_log($e);
	  }
		//Log out if you detect a facebook logout
		if($USER_DATA['user_id']!=0){
		
			if(!$me){
				$cpg_udb->logout_page();
			}
			return false;
		}
		//Do This Better
		if($me){
			
			
			switch($me['locale']){
				case 'en_US':
					$user_language = 'english';
					break;
				default:
					$user_language = 'english';
					break;
			}
			$encpassword = md5($uid);
			$usern = $me['first_name'].$me['last_name'].preg_replace('/\//', '', $me['birthday']);
			$sql = "SELECT user_name, user_email, user_password FROM {$CONFIG['TABLE_USERS']} WHERE user_name = '$usern'";
			$result = cpg_db_query($sql);
			if(mysql_num_rows($result) == 0){
				$sql = "INSERT INTO {$CONFIG['TABLE_USERS']} (user_regdate, user_active, user_actkey, user_name, user_password, user_email, user_profile1, user_profile2, user_profile3, user_profile4, user_profile5, user_profile6, user_language) VALUES (NOW(), 'YES', '', '$usern', '$encpassword', '{$me['email']}', '', '', '', '', '', '', '$user_language')";
				$result = cpg_db_query($sql);
			}
			$USER_DATA = $cpg_udb->login($usern, $uid);		
			cpgRedirectPage('index.php', 'Thanks For Joining Us!', 'Thanks For Joining Us!>', 3);	
		}
	}
	
}
?>